#include "chip.h"

void chip_ioremap_init(void) {
    CHIP_REGS_AFIO->MAPR = 0
#ifdef CHIP_REGFLD_AFIO_MAPR_SPI1_H
            | LBITFIELD_SET(CHIP_REGFLD_AFIO_MAPR_SPI1_H,     ((CHIP_IOREMAP_SPI1 >> 1) & 1))
#endif
#ifdef CHIP_REGFLD_AFIO_MAPR_PTP_PPS
            | LBITFIELD_SET(CHIP_REGFLD_AFIO_MAPR_PTP_PPS,  CHIP_IOREMAP_ETH_PPS)
#endif
#ifdef CHIP_REGFLD_AFIO_MAPR_TIM2_ITR1
            | LBITFIELD_SET(CHIP_REGFLD_AFIO_MAPR_TIM2_ITR1,CHIP_IOREMAP_TIM2_ITR1)
#endif
#ifdef CHIP_REGFLD_AFIO_MAPR_SPI3
            | LBITFIELD_SET(CHIP_REGFLD_AFIO_MAPR_SPI3,     CHIP_IOREMAP_SPI3)
#endif
            | LBITFIELD_SET(CHIP_REGFLD_AFIO_MAPR_SWJ_CFG,  CHIP_IOREMAP_JTAG)
#ifdef CHIP_REGFLD_AFIO_MAPR_CAN2
            | LBITFIELD_SET(CHIP_REGFLD_AFIO_MAPR_CAN2,     CHIP_IOREMAP_CAN2)
#endif
#ifdef CHIP_REGFLD_AFIO_MAPR_ETH
            | LBITFIELD_SET(CHIP_REGFLD_AFIO_MAPR_ETH,      CHIP_IOREMAP_ETH)
#endif
            | LBITFIELD_SET(CHIP_REGFLD_AFIO_MAPR_CAN1,     CHIP_IOREMAP_CAN1)
            | LBITFIELD_SET(CHIP_REGFLD_AFIO_MAPR_TIM4,     CHIP_IOREMAP_TIM4)
            | LBITFIELD_SET(CHIP_REGFLD_AFIO_MAPR_TIM3,     CHIP_IOREMAP_TIM3)
            | LBITFIELD_SET(CHIP_REGFLD_AFIO_MAPR_TIM2,     CHIP_IOREMAP_TIM2)
            | LBITFIELD_SET(CHIP_REGFLD_AFIO_MAPR_TIM1,     CHIP_IOREMAP_TIM1)
            | LBITFIELD_SET(CHIP_REGFLD_AFIO_MAPR_USART1,   (CHIP_IOREMAP_USART1 & 1))
            | LBITFIELD_SET(CHIP_REGFLD_AFIO_MAPR_USART2,   CHIP_IOREMAP_USART2)
            | LBITFIELD_SET(CHIP_REGFLD_AFIO_MAPR_USART3,   CHIP_IOREMAP_USART3)
            | LBITFIELD_SET(CHIP_REGFLD_AFIO_MAPR_I2C1,     CHIP_IOREMAP_I2C1)
            | LBITFIELD_SET(CHIP_REGFLD_AFIO_MAPR_SPI1,     (CHIP_IOREMAP_SPI1 & 1))
            | CHIP_REGFLDSET_AFIO_MAPR_SPI1(CHIP_IOREMAP_SPI1)
            ;

    CHIP_REGS_AFIO->MAPR2 = 0
#if defined CHIP_REGFLD_AFIO_MAPR2_USART1_H && defined CHIP_IOREMAP_USART1
            | LBITFIELD_SET(CHIP_REGFLD_AFIO_MAPR2_USART1_H, ((CHIP_IOREMAP_USART1 >> 1) & 1))
#endif
#if defined CHIP_REGFLD_AFIO_MAPR2_USART8 && defined CHIP_IOREMAP_USART8
            | LBITFIELD_SET(CHIP_REGFLD_AFIO_MAPR2_USART8,  CHIP_IOREMAP_USART8)
#endif
#if defined CHIP_REGFLD_AFIO_MAPR2_USART7 && defined CHIP_IOREMAP_USART7
            | LBITFIELD_SET(CHIP_REGFLD_AFIO_MAPR2_USART7,  CHIP_IOREMAP_USART7)
#endif
#if defined CHIP_REGFLD_AFIO_MAPR2_USART6 && defined CHIP_IOREMAP_USART6
            | LBITFIELD_SET(CHIP_REGFLD_AFIO_MAPR2_USART6,  CHIP_IOREMAP_USART6)
#endif
#if defined CHIP_REGFLD_AFIO_MAPR2_USART5 && defined CHIP_IOREMAP_UART5
            | LBITFIELD_SET(CHIP_REGFLD_AFIO_MAPR2_USART5,  CHIP_IOREMAP_UART5)
#endif
#if defined CHIP_REGFLD_AFIO_MAPR2_USART4 && defined CHIP_IOREMAP_UART4
            | LBITFIELD_SET(CHIP_REGFLD_AFIO_MAPR2_USART4,  CHIP_IOREMAP_UART4)
#endif
#if defined CHIP_REGFLD_AFIO_MAPR2_EXMC_NADV && defined CHIP_IOREMAP_EXMC_NADV
            | LBITFIELD_SET(CHIP_REGFLD_AFIO_MAPR2_EXMC_NADV,  CHIP_IOREMAP_EXMC_NADV)
#endif
#if defined CHIP_REGFLD_AFIO_MAPR2_TIM10 && defined CHIP_IOREMAP_TIM10
            | LBITFIELD_SET(CHIP_REGFLD_AFIO_MAPR2_TIM10,  CHIP_IOREMAP_TIM10)
#endif
        ;
}
